/*-----------------------------------------------------*/
/*--	Micro-EMPIX Semaphores (Sem.c)                -*/
/*--    Ver 1.0 (c) 2004                              -*/
/*--	E             -*/
/*--    ==================================            -*/
/*--    .                  -*/
/*--    .                        -*/
/*--    . .                      -*/
/*-----------------------------------------------------*/

#ifndef _DEFS_H
	#define _DEFS_H
	#include "defs.h"
#endif

#ifndef _PROC_H
	#define _PROC_H
	#include "proc.h"
#endif



/* ====================================================*/
/* ============== Function Prototypes =================*/
/* ====================================================*/

void P(int s);
void V(int s);

/* ====================================================*/
/* =========    ==========*/
/* ====================================================*/

int semaphores [MAXSEM][MAXPROC]; /*   */
int semavalue [MAXSEM];           /*      */


/*         P     */
/*   int s */

void P(int s)
{
	int ps;
	disabl_intr(&ps); /* A   */

	if (semavalue[s]>0)   /*       >0 */
		semavalue[s]--;   /*   */
	else	{			  /*  */
		proctab[current].pstate=BLOCKED; /*    */
		semaphores[s][current]=1;        /*       s */
        reschedule();					 /*    */
	}

	restor_intr (&ps); /*     */
	enable_all_intr(); /*    */
}

/*         S     */
/*   int s */
void V(int s)
{
	int ps;
	int i;
	disabl_intr(&ps); /* A   */
	i=0;
	/*         s */
	while ((semaphores[s][i]!=1)&&(i<=numproc))
		i++;
	if (i==numproc+1) semavalue[s]++; /*    ,     */
	else {
		semaphores[s][i]=0; /*        */
		proctab[i].pstate=READY; /*       */
	}

	restor_intr (&ps); /*     */
	enable_all_intr(); /*    */
}
